#version 300 es

precision highp float;


out vec4 outColor;



precision highp float;

#define t uTime
#define resolution uResolution
////////////////////////// 
#define MAX_STEPS 200
#define MAX_DIST 500.0
#define SURFACE_DIST 0.01
#define DEFAULT_SHADOW_ATT 0.5
#define PROCESSED_LIGHTS 3
#define AMBIENT_INTENSITY 0.2

uniform vec2 uResolution;
uniform float uTime;
uniform float u_time;
uniform float u_test;
uniform vec2 u_mouse;

vec2 uv;

mat4 rotX(in float angle) {
    return mat4(
        1, 0, 0, 0,
        0, cos(angle), - sin(angle), 0,
        0, sin(angle), cos(angle), 0,
    0, 0, 0, 1);
}

mat4 rotY(in float angle) {
    return mat4(
        cos(angle), 0, sin(angle), 0,
        0, 1.0, 0, 0,
        - sin(angle), 0, cos(angle), 0,
    0, 0, 0, 1);
}

vec2 setupSpace(in vec2 f, in vec2 res, float s)
{
    return (f - 0.5 * res.xy) / res.y * s;
}

struct DistanceInfo {
    float dist; // Distance to object
    int id; // Object ID
};

float smin(float a, float b, float k)
{
    float h = clamp(0.5 + 0.5 * (b - a) / k, 0.0, 1.0);
    return mix(b, a, h) - k*h * (1.0 - h);
}

float sdRoundBox(vec3 p, vec3 b, float r)
{
    vec3 q = abs(p) - b;
    return length(max(q, 0.0)) + min(max(q.x, max(q.y, q.z)), 0.0) - r;
}
float city;
// Distance to closest object
// Returns: shadedColor
DistanceInfo distToClosest(vec3 rp /*rayPosition*/)
{
    float ret;
    float a = atan(rp.x, rp.y);
    float s[5];
    // Map

    /*
    vec4 pos = (vec4(vec3(rp),1.0) - vec4(cos(t),1.67,sin(t),1.)) * rotY(t*1.) * rotX(t);
    
    s[1] = length(rp - vec3(sin(t*2.),sin(t)+2.,0)) - 1.0;
    s[2] = length(rp - vec3(sin(t * 1.0 + 3.14), sin(t) + 2.0, 0)) - 1.0;
    */
    //s[0] = length(rp - vec3(cos(t*3.)*10.,sin(t)*5.,sin(t*3.)*10.)) - 2. - sin(rp.x*5.+t*10.)*0.05 + sin(rp.y*5.-t*1.)*0.01;
    s[0] = length(rp - 
        vec3(
            1.5, 
            sin(t) * 1.0+12.00
            , 60.00+sin(t)*10.))
     - 1.5 - sin(rp.x * 10.0 + t*10.0) * 0.05 + sin(rp.y * 1.0 - t*1.0) * 0.01;
    
    float goo = rp.y + sin(rp.x+t)*0.04 + sin(rp.x + t*10.) * 0.2;
    rp.x += t*0.0;
    rp.z += t*200.0;
    // rp.y += t*10.;
    rp.y += sin(t*2.)*2.-13.;
    float shake = sin(t * 80.0) * min(0.2, t*0.01);
    rp.y += shake;
    
    //float morph = 0.03+sin(t * 1.0) * 0.1;
    float morph = 0.03+(t*0.05)*0.1;
    //float morph = sin(t)*1.;

    float city = rp.y +
         floor(sin(rp.x)) +
         floor(sin(rp.z * 0.01+sin(t*0.09)*0.1) + 8.10 +
         sin(rp.x * sin(t*0.01)*0.5+0.5 + 0.79) * 2.0) +
         sin(rp.x*0.05)*(2.*rp.x*-morph);
         
    int id = 10;
    float dist = 1.0;
    for(int i=0; i<1; i++){
        dist = smin(dist, s[i], 0.01);
    }

    if(dist==s[0]){
        id = 0;
    }else{
        id=10;
    }
    
    float plane = mod(city,30.);    
    
    dist = smin(dist, plane,5.);
    

/*
if(dist == s[0]){
        id = 1;
    }else if(dist == s[1]){
        id = 2;
    }else if (dist == s[2]) {
        id = 3;
    }else if(dist == plane){
        id = 0;
    }
  */  
    
    
    
    return DistanceInfo(dist, id);
}


DistanceInfo march(vec3 ro /*rayOrigin*/, vec3 rd /*rayDirection*/)
{
    vec3 color;
    float md; // Marched distance
    DistanceInfo di;
    for(int i = 0; i < MAX_STEPS; i ++ ) {
        vec3 rp = ro + rd * md;
        di = distToClosest(rp);
        md += di.dist;
        if (md > MAX_DIST || di.dist < SURFACE_DIST)break;
    }
    return DistanceInfo(md, di.id);
}

vec3 getNormal(vec3 p) {
    float d = distToClosest(p).dist; // Get distance to surface point
    
    // Normal trick from Art Of Code (using derivatives/slopes)
    vec2 e = vec2(0.1, 0.0);
    //vec3 n = d-vec3(distToClosest(p - e.xyy).dist, distToClosest(p - e.yxy).dist+0.00, distToClosest(p - e.yyx).dist);
    vec3 n = d-vec3(distToClosest(p - e.xyy).dist+0.01, distToClosest(p - e.yxy).dist+0.00, distToClosest(p - e.yyx).dist);
    
    return normalize(n); // Return unit vector because we want a direction
}

struct LightOutput {
    float diffuse;
    float specular;
    float attenuation; // Used for shadows
};

struct LightData {
    vec3 position;
    float intensity;
};

LightOutput light(vec3 ro, vec3 p, vec3 normal, LightData data) {
    // Phong-Blinn
    vec3 lv = normalize(data.position - p); // Get light vector at that point (light pos - surface pos)
    float diffuse = max(dot(normal, lv), 0.0);
    
    // Specular
    vec3 viewVector = normalize(p - ro); // View vector
    vec3 lr = reflect(lv, normal);
    float specular = smoothstep(0.,0.31,pow(max(dot(viewVector, lr), 0.0), 50.0)); // Calculate specular brigthness
        
    // Shadow (from Art Of Code)
    // This is another raymarch
    float attenuation;
    vec3 sv = vec3(p.x+0.00,p.y + 0.00,p.z+0.00);
    float sd = march(sv + normal * SURFACE_DIST * 2.0, lv).dist;

    /*
    if (sd < le) {
        attenuation = DEFAULT_SHADOW_ATT;
    }
    */
    

    return LightOutput(diffuse * data.intensity, specular * data.intensity, attenuation);
}

float calcAO(in vec3 pos, in vec3 nor)
{
    float occ = 0.0;
    float sca = 1.0;
    for(int i = 0; i < 5; i ++ )
    {
        float h = 0.01 + 0.12 * float(i) / 4.0;
        float d = distToClosest(pos + h*nor).dist;
        occ += (h - d) * sca;
        sca *= 0.95;
        if (occ > 0.35)break;
    }
    return clamp(1.0 - 3.0 * occ, 0.0, 1.0) * (0.5 + 0.5 * nor.y);
}

vec3 shade(vec3 rd, vec3 ro, DistanceInfo di) {
    
    vec3 p = ro + rd * di.dist; // Get point to surfaces
    vec3 n = getNormal(p); // Get surface normal for point
    float ao = calcAO(p, n);


    vec3 lightPos = vec3(1.35, 6.00, +3.58 + sin(t * 0.5));
    
    LightOutput lights[3];
    lights[0] = light(ro, p, n, LightData(lightPos, 0.7));
    lights[1] = light(ro, p, n, LightData(lightPos + vec3(-18.85), 0.1));
    lights[2] = light(ro, p, n, LightData(lightPos + vec3(55.00,0.00,64.00), 0.5));
    
    // Ambient color
    vec3 ambient = vec3(AMBIENT_INTENSITY, AMBIENT_INTENSITY, AMBIENT_INTENSITY + 0.34);
    float fog = 1.0 - p.z * 0.1;
    ambient *= vec3(fog+-2.10,fog+-3.00,fog+-7.60);
    ambient += vec3(1)*1.45;
    
    // Object color
    vec3 color = vec3(0);
    if (di.id == 0) { // Plane
        color = vec3(0.12, 0.1, 0.1);
    }
    else if (di.id == 1) {
        color = vec3(0, 1, 0);
    }
    else if (di.id == 2) {
        color = vec3(0, 0, 1);
    } else if (di.id == 3) {
        color = vec3(1.0,0,0);
    }else if(di.id == 10){
        color = vec3(0.8196, 0.2353, 0.2353);

        // CONTAMINATION FX
        //color = vec3(/*0.8196*/di.dist * 0.01, 0.2353, 0.2353);
        // color = vec3(step(sin(n.y*5.)+0.86 + sin(p.y*10.)*0.1,p.x), 0.2353, 0.2353);
        //color = vec3(smoothstep(3.96, sin(n.y*10.)+-27.14 + sin(p.y*10.)*0.1,p.x), 0.2353, 0.2353);
    }
    
    if (di.id != -1) { // If we hit something, calculate color
        float diffuse;
        float specular;
        float attenuation;
        
        // Accumulate lighting intensities from every light
        for(int i = 0; i < PROCESSED_LIGHTS; i ++ ) {
            diffuse += lights[i].diffuse;
            specular += lights[i].specular*0.1;
            attenuation += lights[i].attenuation;
        }
        
        vec3 litColor = (ambient + diffuse) * color + specular;
        return litColor * (1.-attenuation);
        
    }else { // Else, we are in the skybox/background
        return vec3(0);
    }
}

mat3 setCamera(in vec3 ro, in vec3 ta, float cr)
{
    vec3 cw = normalize(ta - ro);
    vec3 cp = vec3(sin(cr), cos(cr), 0.0);
    vec3 cu = normalize(cross(cw, cp));
    vec3 cv = (cross(cu, cw));
    return mat3(cu, cv, cw);
}

vec4 image(vec2 fragCoord, vec2 uv)
{
    // Camera setup
    vec3 ta = vec3(0.5, - 0.5, - 0.6);
    vec3 ro = ta + vec3(
        1. * cos(t)*3.,
        14.00 + sin(t*0.05)*0.3 * 10.,
        100.);
    
    mat3 ca = setCamera(ro, ta, sin(t*0.01)*0.1);
    float fov = 2.5;
    vec3 rd = ca * normalize(vec3(uv, fov));
    
    DistanceInfo di = march(ro, rd); // Get distance to scene objects
    vec3 col = shade(rd, ro, di); // Fragment color. Calculate shading.
    
    return vec4(col, 1.0);
}

void main()
{
    uv = setupSpace(gl_FragCoord.xy, resolution, 1.0);
    outColor = image(gl_FragCoord.xy, uv);
}